(function(c,q){var m="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///ywAAAAAAQABAAACAUwAOw==";c.fn.imagesLoaded=function(f){function n(){var b=c(j),a=c(h);d&&(h.length?d.reject(e,b,a):d.resolve(e));c.isFunction(f)&&f.call(g,e,b,a)}function p(b){k(b.target,"error"===b.type)}function k(b,a){b.src===m||-1!==c.inArray(b,l)||(l.push(b),a?h.push(b):j.push(b),c.data(b,"imagesLoaded",{isBroken:a,src:b.src}),r&&d.notifyWith(c(b),[a,e,c(j),c(h)]),e.length===l.length&&(setTimeout(n),e.unbind(".imagesLoaded",
p)))}var g=this,d=c.isFunction(c.Deferred)?c.Deferred():0,r=c.isFunction(d.notify),e=g.find("img").add(g.filter("img")),l=[],j=[],h=[];c.isPlainObject(f)&&c.each(f,function(b,a){if("callback"===b)f=a;else if(d)d[b](a)});e.length?e.bind("load.imagesLoaded error.imagesLoaded",p).each(function(b,a){var d=a.src,e=c.data(a,"imagesLoaded");if(e&&e.src===d)k(a,e.isBroken);else if(a.complete&&a.naturalWidth!==q)k(a,0===a.naturalWidth||0===a.naturalHeight);else if(a.readyState||a.complete)a.src=m,a.src=d}):
n();return d?d.promise(g):g}})(jQuery);

(function( $ ) {
  "use strict";
  // private Stuff
  var Orientation = { Horizontal : 1, Vertical : 2 };
  var SlideDirection = { Forward : 1, Backward: 2 };
  
  /**
   * @param {String} msg This will print the given error message.
   */
  function print_error(msg) {
    alert(msg);
  }
  
  /**
   * This will swaps the classes if the condition is true,
   * otherwise it will swap it in the other direction.
   *
   * @param {jQuery} container The element where the classes should be switched.
   * @param {String} class1 A stylesheet class name.
   * @param {String} class2 A stylesheet class name.
   * @param {Boolean} condition When true, it will swap the class1 with class2, otherwise vice versa.
   */
  function swapClasses(container, class1, class2, condition) {
    if (condition)
      container.removeClass(class1).addClass(class2);
    else
      container.removeClass(class2).addClass(class1);
  }
  
  /**
   * Creates a button inside the given @parentCt.
   *
   * @param {jQuery} parentCt The parent element, where the button will be appended.
   * @param {String} backgroundStyle The style of the outer div.
   * @param {String} iconStyle The is the style of the inner div.
   * @param {Function} clickFunc A function that will be called when the user clickes on the backgroundStyle.
   * @returns {Object} A button object, which holds the jQuery object and the method 'setAutoHide'.
   *
   * Remark: setAutoHide will show the button when the mouse enters the parentCt and hides the button,
   * when it will leave the parentCt.
   */
  function createButton(parentCt, backgroundStyle, iconStyle, clickFunc) {
    var buttonCt = $("<div>").addClass(backgroundStyle).appendTo(parentCt);
    var iconCt = $("<div>").addClass(iconStyle).appendTo(buttonCt);
    var buttonInstance = {
      jqCt : buttonCt,
      setAutoHide : function (show, container) {
                        if (show === true ){
                          container.mousemove(function() {
                            buttonCt.stop().fadeIn(70);
                          });
                          container.mouseout(function() {
                            buttonCt.stop().fadeOut(70);
                          });

                          setTimeout(function(){
                                                buttonCt.fadeOut(1000)
                                                }, 1500);
                      }
                    }
    };

    buttonCt.click(clickFunc);
    return buttonInstance;
  }
  
  /**
   * A function which creates an animation for a jQuery object.
   *
   * @param {String} cssProperty The name of the css property which should be animated.
   * @param {String} newValue The new target value of the css property.
   * @param {String|Number} duration A string or number determining how long the animation will run.
   * @param {String} easing A string indicating which easing function to use for the transition.
   * @param {jQuery} container The jQuery Object which should be animated.
   * @param {jQuery} finishedFunc A function that will be called, when the animation has finished.
   */
  function createAnimation(cssProperty, newValue, duration, easing, container, finishedFunc) {
    var map = {};
    map[cssProperty] = newValue;
    container.animate(map, duration , easing, finishedFunc)
  }
  
  /**
   * Enables dragging functionality for a given jQuery element.
   * @param {jQuery} container The jQuery container, where dragging will be enabled.
   * @param {Orientation} orient The orientation, in which direction the user can drag the container.
   * @param {Function} A function that will be called when the user has dragged the container and released the mouse button.
   *                   The callback gets a the delta mouse position and the delta time, since last drag. function(mousePosDelta, timeDiffSinceLastDrag)
   */
  function enableDrag(container, orient, mouseUpCallBack) {
    var mouseDown = false;
    var oldMousePos = {x: 0, y: 0};
    var mousePosDelta = {x: 0, y: 0};
    var slideCount = 0;
    var currIndex;
    var oldTime;
    var currTime;
    container.data("hasDragged", false);
    
    /**
     * Returns true if its necessary to drag the container, because
     * some parts are not visible.
     *
     * @returns {Boolean} True, it is neccessary to drag the container, otherwise false.
     */
    function isDragNecessary() {
      if (orient === Orientation.Horizontal) {
        return (container.parent().width() < container.outerWidth(true));
      } else {
        return (container.parent().height() < container.outerHeight(true));
      }
    }

    /**
     * This function will switch between the two styles 'es-cursor-grab'
     * and 'es-cursor-nograb'. So when the user graps the container,
     * the style 'es-cursor-grab' is active, otherwise the style 'es-cursor-nograb'
     * is active.
     *
     * @param {Boolean} enabled When called with true, it will use the style 'es-cursor-grab',
     *                          otherwise 'es-cursor-nograb'.
     */
    function setMouseCursorGrab(enabled) {
      if (!isDragNecessary())
        return;

      if (enabled) {
        container.parent().addClass("es-cursor-grab");
        container.parent().removeClass("es-cursor-nograb");
      } else {
        container.parent().removeClass("es-cursor-grab");
        container.parent().addClass("es-cursor-nograb");
      }
    }
    
    /**
     * Implements the mousedown functionality.
     */
    container.parent().mousedown(function(e){
      // Do we drag the correct container?
      if (!jQuery.contains(container.get(0), $(e.target).get(0)))
        return;

      if (!isDragNecessary())
        return;

      container.data("hasDragged", false);
      container.stop();
      mouseDown = true;
      setMouseCursorGrab(true);
      oldMousePos = {x: e.pageX, y:e.pageY};
      oldTime = $.now();
      if(container.parent().get(0).setCapture)
        container.parent().get(0).setCapture();
    });
    
    /**
     * Implements the mouse up functionality.
     */
    $(document).mouseup(function(e){ 
      if (!mouseDown) {
        return;
      }
      mouseDown = false;
      setMouseCursorGrab(false);
      if(container.parent().parent().get(0).releaseCapture)
        container.parent().parent().get(0).releaseCapture();
      
      var timeDiffSinceLastDrag = e.timeStamp - oldTime;
      mouseUpCallBack(mousePosDelta, timeDiffSinceLastDrag);
      
      mousePosDelta.x = 0;
      mousePosDelta.y = 0;
    });
    
    $(document).mousemove(function(e){
      if (!mouseDown){
        setMouseCursorGrab(false);
        return;
      }
      
      container.data("hasDragged", true);
      mousePosDelta.x = e.pageX - oldMousePos.x;
      mousePosDelta.y = e.pageY - oldMousePos.y;
      var currentPos = container.position();
      var cssPropertyToAnim;
      var newPos;
      if (orient === Orientation.Horizontal) {
        cssPropertyToAnim = "left";
        var offsetWidth = parseInt(container.parent().css("marginLeft"));
        newPos = currentPos.left + mousePosDelta.x - offsetWidth;
        var visibleRange = container.parent().width();
        var maxLeft = -(container.width() - visibleRange);
        var maxRight = 0;
        if (newPos < maxLeft)
          newPos = maxLeft;
        else if(newPos > maxRight)
          newPos = maxRight;
      } else {
        cssPropertyToAnim = "top";
        var offSetHeight = container.parent().outerHeight(true) - container.parent().innerHeight();
        var newPos = currentPos.top + mousePosDelta.y - offSetHeight;
        var visibleRange = container.parent().height();
        var maxTop = -(container.height() - visibleRange);
        var maxBottomo = 0;
        if (newPos < maxTop)
          newPos = maxTop;
        else if(newPos > maxBottomo)
          newPos = maxBottomo;
      }
      container.css(cssPropertyToAnim, newPos);
      oldMousePos.x = e.pageX;
      oldMousePos.y = e.pageY;
      
      oldTime = e.timeStamp;
    });
    
      // disable dragging of imagers via its browser functionaliy
      // otherwise we can't drag the container
      container.bind("dragstart", function(e) {
      if (e.target.nodeName.toUpperCase() == "IMG") {
        return false;
      }
    });
     
  }

  /**
   * Maps the  the given event touch event to the corresponding mouse event.
   * @param {String} event Can be 'touchstart', 'touchmove' or 'touchend'.
   */
  function touchHandler(event) {
    var touches = event.changedTouches,
    first = touches[0],
    type = "";

    switch(event.type)
    {
      case "touchstart": type = "mousedown"; break;
      case "touchmove":  type = "mousemove"; break;        
      case "touchend":   type = "mouseup"; break;
      default: return;
    }
    var simulatedEvent = document.createEvent("MouseEvent");
    simulatedEvent.initMouseEvent(type, true, true, window, 1,
                                  first.screenX, first.screenY,
                                  first.clientX, first.clientY, false,
                                  false, false, false, 0/*left*/, null);

    first.target.dispatchEvent(simulatedEvent);
    event.preventDefault();
  }
  
  /**
   * Creates a navigation bar with the given options.
   *
   * @function addNavBarItem Adds a navigation bar item to navigation bar.
   * @function selectNavBarItem Selects the given navigation bar item.
   * @param options.navBarStyle The different styles of the navigation bar item can be: "custom", "caption" or "thumbs"
   * @param options.navBarEasing  A string indicating which easing function to use for the transition.
   * @param options.navBarEasingDuration A string or number determining how long the animation will run.
   * @param options.navBarAutoHide Indicated whether the navigation bar should hide itself or not.
   * @param options.navBarOrientation The orientation direction of the navigation bar. Can be horizontal or vertical.
   * @param options.navBarDragable Set the option to 'true' to make the navigation bar draggable.
   * @param options.navBarAutoScroll Set the option to 'true' to make the navigation bar automatically scroll to the current selected navbar item.
   */
  function createNavBar(options) {
    var _rootCt, _navBarCT;
    var _nextButton, _prevButton;
    var _totalWidth = 0;
    var _totalHeight = 0;
    var _navItems = [];
    var _cssPropertyToAnim = (options.navBarOrientation === "horizontal") ? "left" : "top";
    var _orientation = (options.navBarOrientation === "horizontal") ? Orientation.Horizontal : Orientation.Vertical;
    var _normalNavBarClassName = "es-navbar-item", _highlightNavBarClassName = "es-navbar-item-selected"; //
    var _rowContainer, _colContainer; //
    function init() {
      _rootCt = $("<div>").addClass("es-navbar-container");
      _navBarCT = $("<ul>").appendTo(_rootCt);
      _nextButton = createButton( _rootCt, "es-navbar-next-container", "es-navbar-next-icon", 
                                  function(e) { 
                                    e.preventDefault();
                                    var endPos;
                                    if (_orientation === Orientation.Horizontal) {
                                      endPos = _navBarCT.position().left - _rootCt.width();
                                      endPos = (endPos <= getMaxLeft()) ? getMaxLeft() : endPos;
                                    } else {
                                      endPos = _navBarCT.position().top - _rootCt.height();
                                      endPos = (endPos <= getMaxTop()) ? getMaxTop() : endPos;
                                    }
                                    createAnimation( _cssPropertyToAnim, endPos, 
                                                     options.navBarEasingDuration, 
                                                     options.navBarEasing,
                                                     _navBarCT,
                                                     checkAutoHideNavButtons);
                                  });
      _prevButton = createButton( _rootCt, "es-navbar-prev-container", "es-navbar-prev-icon",
                                  function(e) {
                                    e.preventDefault();
                                    var endPos;
                                    if (_orientation === Orientation.Horizontal) {
                                      endPos = _navBarCT.position().left + _rootCt.width();
                                      endPos = (endPos >= getMaxRight()) ? getMaxRight() : endPos;
                                    } else {
                                      endPos = _navBarCT.position().top + _rootCt.height();
                                      endPos = (endPos >= getMaxBottom()) ? getMaxBottom() : endPos;
                                    }
                                    createAnimation(_cssPropertyToAnim, endPos, 
                                                    options.navBarEasingDuration,
                                                    options.navBarEasing,
                                                    _navBarCT,
                                                    checkAutoHideNavButtons);
                                  });

      // When the window is resized, we might adjust the navBar position, 
      // the reason for that is when the visible range of the navbar is decrased
      // we can also move the navbar container more to the left.
      // When we increase the visible range of the navbar, we have to adjust the left position
      // to avoid empty gaps
      $(window).bind("resize", function() {
      
        if (_orientation === Orientation.Horizontal) {
          var currPos = _navBarCT.position().left;
          var newPos = (currPos <= getMaxLeft()) ? getMaxLeft() : currPos;
          if (_navBarCT.width() >= _rootCt.width())
            _navBarCT.css(_cssPropertyToAnim, newPos);
        } else {
          var currPos = _navBarCT.position().top;
          var newPos = (currPos <= getMaxTop()) ? getMaxTop() : currPos;
          if (_navBarCT.height() >= _rootCt.height())
            _navBarCT.css(_cssPropertyToAnim, newPos);
        }
      });

      if (options.navBarDragable) {
        enableDrag(_navBarCT, _orientation, function(mouseDelta, timeDiffSinceLastDrag) {
        if (timeDiffSinceLastDrag >= 40)
        {
          checkAutoHideNavButtons();
          return;
        }
        var endPos;
        if (_orientation === Orientation.Horizontal) {
          var endPos = _navBarCT.position().left + mouseDelta.x * 15;
          if (endPos < getMaxLeft())
            endPos = getMaxLeft();
          else if(endPos > getMaxRight())
            endPos = getMaxRight();
        } else {
          var endPos = _navBarCT.position().top + mouseDelta.y * 15;
          if (endPos < getMaxTop())
            endPos = getMaxTop();
          else if(endPos > getMaxBottom())
            endPos = getMaxBottom();
        }
        createAnimation( _cssPropertyToAnim,  endPos, 400,
                         "easeOutQuart",
                         _navBarCT,
                         checkAutoHideNavButtons);
          });
      }
    }
    
    /**
     * @returns {Number} The maximum left position of the navigation bar.
     */
    function getMaxLeft() {
      return -(_navBarCT.width() - _rootCt.width());
    }
    /**
     * @returns {Number} The maximum right position of the navigation bar.
     */
    function getMaxRight() {
      return 0;
    }
    
    /**
     * @returns {Number} The maximum top position of the navigation bar.
     */
    function getMaxTop() {
      return -(_navBarCT.height() - _rootCt.height());
    }
    /**
     * @returns {Number} The maximum bottom position of the navigation bar.
     */
    function getMaxBottom() {
      return 0;
    }
    
    /**
     * Returns true if its necessary to drag the container, because
     * some parts are not visible.
     *
     * @returns {Boolean} Returns true when the navigation bar is bigger then its parent container.
     */
    function isDragNecessary() {
      if (_orientation === Orientation.Horizontal) {
        return (_rootCt.width() <= _navBarCT.outerWidth(true));
      } else {
        return (_rootCt.height() <= _navBarCT.outerHeight(true));
      }
    }
    
    /**
     * Creates a navigation bar item,
     *
     * @param {Number} id The id of the navbar.
     * @param {String|jQuery} caption The caption for the navBar item.
     * @param {Function} clickCB A function that will be called, when the navbar item was clicked.
     */
    function createNavBarItem(id, caption, clickCB) {
      var li = $("<li>");
      if (options.navBarStyle === "caption") {
        if (!caption || caption.length === 0) {
          print_error("empty caption for slide id: " + id);
          litext("empty text");
        }
        else if (caption instanceof jQuery) {
          li.append(caption.children());
        }
        else {
          li.text(caption);
        }
      }
      else if (options.navBarStyle !== "custom") {
        print_error("unknown option: navBarStyle - " + options.navBarStyle);
      }

      li.addClass(_normalNavBarClassName);

      li.click(function (e) { 
        e.preventDefault(); // avoid execution of default action
        if (!li.parent().data('hasDragged'))
          clickCB();
      });
      
      if (options.navBarItemOnHoverGoTo) {
        li.hover(function (e) { 
          e.preventDefault(); // avoid execution of default action
          if (!li.parent().data('hasDragged'))
            clickCB();
        });
      }
      
      return li;
    }

    /**
     * This function will highlight the given jQuery item,
     * when highlight is true, otherwise not.
     *
     * @param {jQuery} item The item which should be highlighted.
     * @param {Boolean} highlight When true, the given item will use the
     *                  class '_highlightNavBarClassName' otherwise the class '_highlightNavBarClassName'.
     */
    function setHighlightNavBarItem(item, highlight) {
      swapClasses(item, _normalNavBarClassName, _highlightNavBarClassName, highlight);
    }
    
    /**
     * This function will checks whether the both navigation bar arrow buttons
     * should be visible or not.
     * When they are necessary to show, they will be visible, otherwise not.
     */
    function checkAutoHideNavButtons() {
      var currPos = _navBarCT.position();
      _nextButton.jqCt.show();
      _prevButton.jqCt.show();
      if (_orientation === Orientation.Horizontal) {
        if (currPos.left >= getMaxRight())
          _prevButton.jqCt.hide();
        if (currPos.left <= getMaxLeft())
          _nextButton.jqCt.hide();
      }
      else {
        if (currPos.top >= getMaxBottom())
          _prevButton.jqCt.hide();
        if (currPos.top <= getMaxTop())
          _nextButton.jqCt.hide();
      }
    }
    
    /**
     * Helper method to build an object literal,
     * where the keys are sorted depending of the 
     * current css property posProperty.
     * The values are an Array of all those elements 
     * which has the same css property value.
     * The element are from the Array itemList.
     *
     * e.g. in this form {0: [li1, li2], 32: [li3, li4]} 
     * where '0' and '32' are value of posProperty (e.g. "left")
     * So in fact it is a simple multimap. Where I map css properties
     * to is elements.
     *
     * @param {Array} listOfItems An Array of jQuery items.
     * @param {String} posProperty A css property.
     * @returns {Object} An object literal in this form { key: [], key: [] }
     */
    function buildPropertyContainer(itemList, posProperty) {
      var tmpMap = {};
      for (var i = 0; i < itemList.length; ++i) {
        var currItemPos = itemList[i].position()[posProperty];
        if (!tmpMap[currItemPos])
          tmpMap[currItemPos] = new Array(itemList[i]);
        else
          tmpMap[currItemPos].push(itemList[i]);
      }
      var orderedKeys = $.map(tmpMap, function (value, key) { return key; });
      orderedKeys.sort(function(a, b) { return (a - b); });
      var result = {};
      for (var i = 0; i < orderedKeys.length; ++i) {
        // it is importand, that we can iterate over the object literal in the order
        // of definition, but some browsers iterate first over numbers, than strings;
        // more info here: http://javascript.info/tutorial/objects
        result["_" + orderedKeys[i]] = tmpMap[orderedKeys[i]];
      }
      return result;
    }
    
    /**
     * This function will update the property containers.
     */
    function updateContainers() {
      _rowContainer = {};
      _colContainer = {};
      _rowContainer = buildPropertyContainer(_navItems, 'top');
      _colContainer = buildPropertyContainer(_navItems, 'left');
    }
    
    /**
     * This function return the index number, where the item
     * was found inside the itemList.
     * @returns {Number} The index at which the item was found.
     */
    function findItem(item, itemList) {
      var index = 0;
      var foundItem = false;
      $.each(itemList, function(key, value) {
        for (var i = 0; i < value.length; ++i) {
          if (value[i].get(0) === item.get(0)) {
            foundItem = true;
            return false;
          }
        }
        ++index;
      });

      if (foundItem);
        return index;
    }
    
    /**
     * @returns {Number} The row index of the given item. Otherwise undefined.
     */
    function getRowIndex(item) {
      return findItem(item, _rowContainer);
    }
    
    /**
     * @returns {Number} The column index of the given item. Otherwise undefined.
     */
    function getColumnIndex(item) {
      return findItem(item, _colContainer);
    }
    
    /**
     * @returns {Number} The current row count of the navigation bar.
     */
    function getRowCount() {
      var count = 0;
      $.each(_rowContainer, function (key) { ++count; } );
      return count;
    }
    
    /**
     * @returns {Number} The current column count of the navigation bar.
     */
    function getColumnCount() {
      var count = 0;
      $.each(_colContainer, function (key) { ++count; } );
      return count;
    }
   
    /**
     * This function will return the maximum css property value
     * of the given itemList.
     * @param {Number} index The index of itemList (So which key index should be used).
     * @param {Object} itemList The css property Object
     * @param {String} dimProperty The name of the css property.
     * @returns {Number} The maximum css value.
     */
    function getRowColumWidthHeight(index, itemList, dimProperty) {
      var count = 0;
      var minHeight = 0;
      $.each(itemList, function (key, value) { 
        if (count === index) {
          for (var i = 0; i < value.length; ++i) {
            minHeight = Math.max(minHeight, value[i][dimProperty](true));
          }
        }
        ++count;
      });
      
      return minHeight;
    }
    
    /**
     * @param {Number} rowIndex A row index.
     * @returns {Number} The height of the given row.
     */
    function getRowHeight(rowIndex) {
      return getRowColumWidthHeight(rowIndex, _rowContainer, "outerHeight");
    }
    
    /**
     * @param {Number} colIndex A column index.
     * @returns {Number} The width of the given column.
     */
    function getColumnWidth(colIndex) {
      return getRowColumWidthHeight(colIndex, _colContainer, "outerWidth");
    }
    
    /**
     * Returns the value of the given posProperty from the first item of the key index.
     *
     * @param {Number} index The index of itemList (So which key index should be used).
     * @param {Object} itemList 
     * @param {String} posProperty The name of the css property.
     * @returns {Number} The value of the given posProperty.
     */
    function getRowColumnPos(index, itemList, posProperty) {
      var count = 0;
      var result;
      $.each(itemList, function (key, value) { 
        if (count === index) {
          result = value;
          return false;
        }
        ++count;
      });
      if (result)
        return result[0].position()[posProperty];
    }
    
    /**
     * Returns the vertical position of the row at the given index.
     *
     * @param {Number} rowIndex The index of the row.
     * @returns {Number} The vertical position of the row.
     */
    function getRowPos(rowIndex) {
      return getRowColumnPos(rowIndex, _rowContainer, "top");
    }
    
    /**
     * Returns the horizontal position of the column at the given index.
     *
     * @param {Number} colIndex The index of the row.
     * @returns {Number} The horizontal position of the column.
     */
    function getColumnPos(colIndex) {
      return getRowColumnPos(colIndex, _colContainer, "left");
    }
    
    /**
     * Returns true if an item with given dimension and position isFinite
     * hidden or not.
     *
     * @param {Number} visibleRange The visible range.
     * @param {Number} cellDim The dimension of the item (width/height).
     * @param {Number} cellPos The position of the item.
     * @returns {Boolean} Returns true if the item is hidden; otherwise not.
     */
    function isRowColumnHidden( visibleRange, cellDim, cellPos) {
      if (visibleRange === 0)
        return { isHidden: false, hiddenRange: 0};
      if (cellPos < 0)
        return { isHidden: true, hiddenRange: Math.abs(cellPos)};
      var endPos = cellPos + cellDim;
      if (endPos > visibleRange)
        //return { isHidden: true, hiddenRange: Math.abs(visibleRange - endPos)};
        return { isHidden: true, hiddenRange: -Math.abs(visibleRange - endPos)};
      else
        return { isHidden: false, hiddenRange: 0};
    }

    /**
     * Returns true if the column at the given index colIndex 
     * is hidden or not.
     *
     * @param {Number} colIndex The index of the column.
     * @returns {Boolean} Returns true if the column is hidden; otherwise false.
     */
    function isColumnHidden(colIndex) {
      if (colIndex >= _navItems.length || colIndex < 0)
        return { isHidden: false, hiddenRange: 0};
      return isRowColumnHidden(_rootCt.width(), getColumnWidth(colIndex),
                              _navBarCT.position().left + getColumnPos(colIndex));
    }
    
    /**
     * Returns true if the row at the given index rowIndex 
     * is hidden or not.
     *
     * @param {Number} colIndex The index of the row.
     * @returns {Boolean} Returns true if the row is hidden; otherwise false.
     */
    function isRowHidden(rowIndex) {
      if (rowIndex >= _navItems.length || rowIndex < 0)
        return { isHidden: false, hiddenRange: 0};
      return isRowColumnHidden(_rootCt.height(), getRowHeight(rowIndex),
                              _navBarCT.position().top + getRowPos(rowIndex));
    }
    
    /**
     * Calculates a new end position for the navigation bar when necessary.
     * That means, when the previouse or next navbar item is hidden, it will
     * calculate a new position, so that these items are visible.
     *
     * @param {Number} currPos The position of the current item.
     * @param {Number} currIndex The index of the current item.
     * @param {String} posProperty The css property
     * @param {Function} hiddenInfoFunc The item function to determine if an item is visible or not.
     * @returns {Number} The end position of the navigation bar when items are hidden, or undefined
     *                   when no transformation is necessary.
     */
    function getOffset(currPos, currIndex,
                       posProperty, hiddenInfoFunc) {
      var endPos;
      var currItem = hiddenInfoFunc(currIndex);
      var nextItem = hiddenInfoFunc(currIndex + 1);
      var prevItem = hiddenInfoFunc(currIndex - 1);
      if (currItem.isHidden) {
        if (currItem.hiddenRange >= 0) {
          if (prevItem.isHidden)
            return _navBarCT.position()[posProperty] + prevItem.hiddenRange;
          else
            return _navBarCT.position()[posProperty] + currItem.hiddenRange;
        }
        else {
          if (nextItem.isHidden)
            return _navBarCT.position()[posProperty] + nextItem.hiddenRange;
          else
            return _navBarCT.position()[posProperty] + currItem.hiddenRange;
        }
      } else {
        if (nextItem.isHidden)
          return _navBarCT.position()[posProperty] + nextItem.hiddenRange;
        if (prevItem.isHidden)
          return _navBarCT.position()[posProperty] + prevItem.hiddenRange;
      }
    }
    
    /**
     * Shows and selects the given navigation bar item.
     *
     * @param {Number} id The index id of the navigation bar item.
     * @param {Boolean} show When called with 'true' it will selects the given navigation bar item;
     *                       otherwise it will deselect it.
     */
    function showNavBarItem(id, show) {
      var item = _navItems[id];
      var endPos;
      
      setHighlightNavBarItem(item, show);
      if (!show || !isDragNecessary())
      {
        checkAutoHideNavButtons();
        return;
      }
      
      if (!options.navBarAutoScroll)
        return;
      
      // stop exisiting animation      
      _navBarCT.stop();
      
      updateContainers();
      if (_orientation === Orientation.Horizontal) {
        var currColumn = getColumnIndex(item);
        endPos = getOffset(_navBarCT.position().left + getColumnPos(currColumn),
                           currColumn, "left",
                           isColumnHidden);
      } else {
        var currRow = getRowIndex(item);
        endPos = getOffset(_navBarCT.position().top + getRowPos(currRow),
                           currRow, "top",
                           isRowHidden);
      }

      if (endPos !== undefined) {
        createAnimation(_cssPropertyToAnim, endPos, 
                        options.navBarEasingDuration, 
                        options.navBarEasing,
                        _navBarCT,
                        checkAutoHideNavButtons);
      }
      else {
        checkAutoHideNavButtons();
      }
    }
    
    init();
    var instance = {
      navbarCt          : _rootCt,
      addNavBarItem     : function(caption, clickCallback) {
                            var navItem = createNavBarItem(_navItems.length, caption, clickCallback);
                            _navItems.push(navItem);
                            _navBarCT.append(navItem);
                          },
      selectNavBarItem  : function(id, select) {
                            showNavBarItem(id, select);
                          }
    }

    return instance;
  }
  
  /**
   * Extracts any caption of the given element.
   *
   * @param {jQuery} element The element from which the caption should be extracted.
   * @returns {String|jQuery} The extracted caption.
   */
  function getCaption(element) {
    var caption = element.find(".es-caption");
    if (caption.length === 0) {
      if (element.is("img")) {
        return element.attr("alt");
      }
      if (element.is("a")) {
        if (element.hasClass("es-img"))
          return element.text();
      }
      else {
        caption = element.find("img");
        return caption.attr("alt");
      }
    }
    
    return caption.detach();
  }
  
  /**
   * @param {jQuery} element The element from which the caption should be extracted.
   * @returns {Object} 
   */
  function getLazyLoadImage(element) {
    var lazyImgsToLoad = [];
   
    function createLazyInfo() {
      var lazyTag = $(this);
      var tmpImg = $("<img>").addClass("es-preloader");
      var loadedLazyIMG = false;
      var lazyInfo = { lazyImageName : lazyTag.attr("href"),
                       jqCt : tmpImg,
                       load : function() {
                                if (loadedLazyIMG)
                                  return;
                                  
                                loadedLazyIMG = true;
                                $("<img>")
                                .attr("src", this.lazyImageName)
                                .imagesLoaded( function(image) {
                                  tmpImg.replaceWith(image);
                                });
                       }};
      lazyTag.replaceWith(tmpImg);
      lazyImgsToLoad.push(lazyInfo);
    }
    
    function loadAllLazyImages() {
      for (var i = 0; i < lazyImgsToLoad.length; ++i) {
        lazyImgsToLoad[i].load();
      }
    }
    
    if (element.is("a")) {
      element.each(createLazyInfo);
      return {container: lazyImgsToLoad[0].jqCt, loadImages: loadAllLazyImages};
    } else {
      element.find("a.es-img").each(createLazyInfo);
      return {container: element, loadImages: loadAllLazyImages };
    }
  }
  
  /**
   * Creates an instance of an slider object.
   *
   * @param {jQuery} element The element from which the slide should be created.
   * @param {Number} index The index number of the slide.
   * @returns {Object} A slider object.
   */
  function createSlide(element, index, parentCt) {
    var li = $("<li>");
    var captionItem = getCaption(element);
    var lazyImages = getLazyLoadImage(element);
   
    if (lazyImages.length === 0) {
      li.append(element);
    } else {
      li.append(lazyImages.container);
    }
     
    var slideInstance = { id            : index,
                          jqSlideCt     : li,
                          caption       : captionItem,
                          goTo          : function () {
                                            setCurrentSlideId(index);
                                          },
                          loadLazyIMG   : function () {
                                            if (lazyImages)
                                              lazyImages.loadImages();
                                          }
                    };
    li.data("loadLazyIMG", slideInstance.loadLazyIMG);
    return slideInstance;
  }
  
  /**
   * This function creates from a list of jQuery items slider objects.
   *
   * @param {jQuery} A list of jQuery items.
   * @returns {Object} A list of all created objects.
   */
  function createSliderObjects(contentList) {
    if (contentList.length === 0)
      print_error("Ther are no slides definied in " + name);
  
    var result = [];
    contentList.each(function (index, value) {
      result.push(createSlide($(this), index));
    });

    return result;
  }

  /**
   * Initalize the slider (e.g. create all necessary html objects and etc.)
   */
  function createSlider(container, options) {
    var _settings = {};
    var _allSlides = []; // this container holds all slide items
    var _rootCt = container; // this is the root element, where the user definied the slider
    var _sliderCt = $("<div>"); //
    var _sliderListCt = $("<ul>"); //
    var _currSlideId; //
    var _timerId; //
    var _navBar; // A handle to the navigation bar
    var _lastSlideDirection = SlideDirection.Forward;
    var _settings = options;
    
    /** 
     * @param {Number} id The slider id index.
     * @returns {Number} Returns the slide with the given id.
     */
    function getSlide(id) {
      if (id >= 0 && id < _allSlides.length) {
        return _allSlides[id];
      }
      else {
        return undefined;
      }
    }
    
    /**
     * @param {Number} id Set the slide with the given id to be the current one.
     * @param {Boolean} [withTurn] When true, the animation should be not direct.
     *                             instead it should loop over all slides in the other direction.
     */
    function setCurrentSlideId(id, withTurn) {
      // finish any previouse animation
      _sliderListCt.stop();
      var slide = getSlide(id);
      if (slide == undefined)
        return;
    
      if (_navBar) {
        if (_currSlideId != undefined)
          _navBar.selectNavBarItem(_currSlideId, false);
          
          _navBar.selectNavBarItem(id, true);
      }
      
      if (_settings.animation === "scroll"){
        if (_currSlideId != undefined)
          doScrollAnimation(getSlide(_currSlideId), getSlide(id), withTurn);
        else
          doScrollAnimation(getSlide(0), getSlide(id));
      }
      
      _currSlideId = id;
      if (_settings.autoSlide)
        startTimer(_currSlideId);
    }
    
    /**
     * Go from the current slide to the next one.
     */
    function nextSlide() {
      var nextId = _currSlideId + 1;
      if (_settings.slideLoop || _settings.slideLoopRewind)
        nextId = getSuccessorSlideId(_currSlideId, 1);
      else if (nextId >= _allSlides.length)
        return;

      setCurrentSlideId(nextId, _settings.slideLoop);
    }

    /**
     * Go from the current slide to the previouse one.
     */
    function prevSlide() {
      var prevId = _currSlideId - 1;
      if (_settings.slideLoop || _settings.slideLoopRewind)
        prevId = getPredecessorSlideId(_currSlideId, 1);
      else if (prevId < 0)
        return;

      setCurrentSlideId(prevId, _settings.slideLoop);
    }
    
    /**
     * The function returns the slides that are necessary to
     * slide from fromSlide to toSlide.
     *
     * @param {Object} fromSlide The start slide.
     * @param {Object} toSlide The target slide.
     * @param {Number} maxSlidesBetween The maximum amount of slide between fromSlide and toSlide.
     * @returns {Array} An array of slides.
     */
    function retrieveSlidesToScroll(fromSlide, toSlide, maxSlidesBetween) {
      var incrFunc;
      var result = [];
     
      if (fromSlide.id > toSlide.id){
        incrFunc = getPredecessorSlideId;
      } else if (fromSlide.id < toSlide.id){
        incrFunc = getSuccessorSlideId;
      }
      else{
        return undefined;
      }
      
      maxSlidesBetween = (maxSlidesBetween === 0) ? Math.abs(fromSlide.id - toSlide.id) : maxSlidesBetween;
      
      var loops = 0;
      var nextSlideId = incrFunc(fromSlide.id, 1);
      while (loops < maxSlidesBetween) {
        var slide = getSlide(nextSlideId);
        if (slide.id == toSlide.id)
          break;

        result.push(slide.jqSlideCt);
        ++loops;
        nextSlideId = incrFunc(nextSlideId, 1);
      }

      result.push(toSlide.jqSlideCt);
      
      if (fromSlide.id > toSlide.id)
        return result.reverse();

      return result;
    }
    
    /**
     * Creates a scroll animation for  sliding from fromSlide
     * to toSlide.
     *
     * @param {Object} fromSlide The slide to start from.
     * @param {Object} toSlide The target slide.
     * @param {Boolean} [withTurn] When true, the animation should be not direct.
     *                             instead it should loop over all slides in the other direction.
     */
    function doScrollAnimation(fromSlide, toSlide, withTurn) {
      var offSetPosition = 0;
      if (_sliderListCt.data('hasDragged')) {
        var offSetWidth = parseInt(_sliderCt.css("marginLeft"));
        offSetPosition = _sliderListCt.position().left + (fromSlide.jqSlideCt.index() * fromSlide.jqSlideCt.width()) - offSetWidth;
      } else {
        offSetPosition = _sliderListCt.position().left + (fromSlide.jqSlideCt.index() * fromSlide.jqSlideCt.width());
      }

      function normalScroll() {
        var slidesToInsert = retrieveSlidesToScroll(fromSlide, toSlide, _settings.slidesToScrollMax);
        if (fromSlide.id < toSlide.id){
          fromSlide.jqSlideCt.after(slidesToInsert);
        }
        else {
          fromSlide.jqSlideCt.before(slidesToInsert);
        }
      }
      
      if (!withTurn || (_allSlides.length === 2)) {
        normalScroll();
      } else {
        if (fromSlide.id == 0 && toSlide.id == (_allSlides.length - 1))
          fromSlide.jqSlideCt.before(toSlide.jqSlideCt);
        else if (fromSlide.id == (_allSlides.length - 1) && toSlide.id == 0)
          fromSlide.jqSlideCt.after(toSlide.jqSlideCt);
        else {
          normalScroll();
        }
      }
      
      var allChilds = _sliderListCt.children();
      // while sliding, load all images, which are not already loaded
      allChilds.each(function() {
        var func = $(this).data("loadLazyIMG");
        if (func)
          func();
      });

      _sliderListCt.css("width", 100 * allChilds.length +"%");
      _sliderListCt.children().css("width", (100 / allChilds.length) + "%");

      var endPos = toSlide.jqSlideCt.index()*(-100) + "%";
      var startPos = fromSlide.jqSlideCt.index()*(-100) + "%";
      _sliderListCt.css("left", startPos);
      _sliderListCt.css("left", "+=" + offSetPosition);
      createAnimation("left", endPos, 
                      _settings.transitionSpeed,
                      _settings.slideEasing,
                      _sliderListCt,
                      function(){slideScrollFinished(toSlide)});
    }
    
    /**
     * Returns a list of slides with predecessors
     * and successors starting from middleSlide. 
     *
     * @param {Object} middleSlide Is placed in the middle of the list.
     * @param {Number} count The number of predecessors and successors.
     *                 If zero, then every slides will be returned.
     * @returns {Array} An array of slides.
     */
    function getSlidesForDragging(middleSlide, count) {
      var result = [];
      var maxSlides, startId;
      var maxSlidesPerSide = Math.floor((_allSlides.length - 1) / 2);
      if ((count > maxSlidesPerSide) || (count === 0)){
        count = maxSlidesPerSide;
      }
      
      if (_settings.slideLoop || _settings.slideLoopRewind) {
        if (count === 0) // when it is set, it means all slides should be draggable
          maxSlides = _allSlides.length;
        else
          maxSlides = (count * 2) + 1;

        if (count === 0)
          startId = 0;
        else
          startId = getPredecessorSlideId(middleSlide.id, count);
      }
      else { // no loop, so we have to make sure that we not add slide beyond the borders
        if (count === 0) {
          startId = 0;
          maxSlides = _allSlides.length;
        }
        else {
          var firstId = middleSlide.id - (count);
          var lastId = middleSlide.id + (count);
          if (firstId < 0)
            startId = 0;
          else if (lastId > (_allSlides.length - 1))
            startId = middleSlide.id - (count) - (lastId - (_allSlides.length - 1));
          else
            startId = middleSlide.id - (count);
          
          maxSlides = (count * 2) + 1;
        }
      }

      while(result.length != maxSlides){
        result.push(_allSlides[startId]);
        startId = ((startId + 1) >= _allSlides.length) ? 0 : startId + 1;
      }
      return result;
    }
    
    /**
     * The modulo in javascript is broken, it will return negative digits.
     * This func will fix it.
     * @param {Number} x
     * @param {Number} y
     */  
    function modulo(x,y) {
      return ((x%y)+y)%y;
    }
    
    /**
     *
     */
    function moduloInRange(min, max, start, count) {
      return modulo((start - min) + count, (max - min) + 1);
    }

    /**
     * Returns the count successor for the given slide id.
     * e.g. When we have 15 slides an I want the third successor of 13
     * this function will return 1.
     */ 
    function getSuccessorSlideId(id, count){
      return moduloInRange(0, _allSlides.length - 1, id, count);
    }
    /**
     * Returns the count predecessor for the given slide id.
     * e.g. When we have 15 slides an I want the third predecessor of 1
     * this function will return 13.
     */ 
    function getPredecessorSlideId(id, count) {
      return moduloInRange(0, _allSlides.length - 1, id, -count);
    }
    
    /**
     * This function gets called, when the slide animation has finished.
     * @param {jQuery} toSlide The target slide.
     */
    function slideScrollFinished(toSlide) {
      _sliderListCt.empty();
      if (_settings.slidesDragable) {
        var slidesToInsert = getSlidesForDragging(toSlide, _settings.slidesToDragMax);
        var widthPerSlide = 100 / slidesToInsert.length + "%";
        _sliderListCt.css("width", slidesToInsert.length * 100 + "%");
        for (var i = 0; i < slidesToInsert.length; ++i){
          slidesToInsert[i].loadLazyIMG();
          _sliderListCt.append(slidesToInsert[i].jqSlideCt);
          slidesToInsert[i].jqSlideCt.css("width", widthPerSlide);
        }
        var newPos = (toSlide.jqSlideCt.index() * (-100)) + "%"; 
        _sliderListCt.css("left", (toSlide.jqSlideCt.index() * (-100)) + "%");
      }
      else {
        _sliderListCt.css("width", "100%");
        _sliderListCt.css("left", "0%");
        _sliderListCt.append(toSlide.jqSlideCt);
        toSlide.jqSlideCt.css("width", "100%");
      }
    }
    
    /**
     * Abort the automatic slider timer.
     */
    function abortCurrentTimer() {
      if (_timerId)
        clearTimeout(_timerId);
    }
    
    /**
     * Starts the automatic slider timer.
     */
    function startTimer(slideId) {
      if (_timerId)
        clearTimeout(_timerId); // kill any previouse timer

      _timerId = setTimeout(function(){
                              setCurrentSlideId(getSuccessorSlideId(slideId, 1))
                            }, _settings.autoSlideTime);
    }
    
    /**
     * Extracts and creates the slides items.
     *
     * @param {jQuery} container The container, where to extract the slides.
     */
    function extractSlides(container) {
      if (container.length === 0) {
        print_error("Unable to create slider\nCannot find tag: " + container.attr("name"));
        return;
      }
      
      var childrenList = container.children();
      _sliderCt.addClass("es-slider-container").appendTo(container);
      _allSlides = createSliderObjects(childrenList, _sliderListCt);
      if (!_allSlides) {
        print_error("Could not created any slides: " + container.attr("name"));
        return;
      }
      
      _sliderCt.append(_sliderListCt);
    }
    
    /**
     * Creates a navigation bar.
     *
     * @param {jQuery} parentCt The container, where to append the navigation bar.
     * @param {Array} slides The array of slides.
     */
    function createNavigationBar(parentCt, slides) {
      var navBar = createNavBar(_settings.navControl);
      parentCt.append(navBar.navbarCt);
  
      for (var i = 0; i < _allSlides.length; ++i) {
        navBar.addNavBarItem(_allSlides[i].caption, 
                              function(num) { 
                                return function() {
                                setCurrentSlideId(num);} }(i) );
      }

      return navBar;
    }
    
    /**
     * Creates two navigation arrow buttons.
     *
     * @param {jQuery} parentCt The container, where to append the arrow navigation button.
     */
    function createArrowNavButtons(parentCt) {
      var autoHide = _settings.navControl.navArrowsAutoHide;
      var buttonNextCt = createButton(parentCt, "es-slide-next-container", "es-slide-next-icon", function(e) { e.preventDefault(); nextSlide(); } );
      var buttonPrevCt = createButton(parentCt, "es-slide-prev-container", "es-slide-prev-icon", function(e) { e.preventDefault(); prevSlide(); } );
      buttonNextCt.setAutoHide(autoHide, _rootCt);
      buttonPrevCt.setAutoHide(autoHide, _rootCt);
    }
    
    /**
     * Makes the given container draggable.
     *
     * @param {jQuery} container The container, which should be made draggable.
     */
    function makeSlidesDraggable(container) {
      enableDrag(container, Orientation.Horizontal, function(mouseDelta, timeDiffSinceLastDrag) {
        if (mouseDelta.x > 0) {
          prevSlide();
          _lastSlideDirection = SlideDirection.Backward;          
        }
        else if (mouseDelta.x < 0) {
          nextSlide();
          _lastSlideDirection = SlideDirection.Forward;
        }
      });
      
      _rootCt.get(0).addEventListener("touchstart", touchHandler, true);
      _rootCt.get(0).addEventListener("touchmove", touchHandler, true);
      _rootCt.get(0).addEventListener("touchend", touchHandler, true);
      _rootCt.get(0).addEventListener("touchcancel", touchHandler, true);
    }
    
    /**
     * Makes the container to slide by clicking.
     *
     * @param {jQuery} container The container, which should move the slides by clicking.
     */
    function enableSlideByClick(container) {
      container.click(function() {
        // the mouseup during draggin is also like a mouse click
        // so we have to avoid a double slide
        if (_sliderListCt.data('hasDragged'))
          return;

        if (_lastSlideDirection == SlideDirection.Forward)
          nextSlide();
        else
          prevSlide();
      });
    }
    
    /**
     * Init the slides.
     */
    function init() {
      extractSlides(_rootCt);
      if (_settings.navControl.navBarStyle === "caption" ||
          _settings.navControl.navBarStyle === "custom"){
        _navBar = createNavigationBar(_rootCt);
      }
      if (_settings.navControl.navArrowsVisible){
        if (_settings.controlsInside)
          createArrowNavButtons(_sliderCt);
         else
          createArrowNavButtons(_rootCt);
      }
      if (_settings.slidesDragable) {
        makeSlidesDraggable(_sliderListCt);
      }
      if (_settings.slideByClick) {
        enableSlideByClick(_sliderListCt);
      }
      
      var transitionSpeed = _settings.transitionSpeed;
      var navBarEasingDuration = _settings.navControl.navBarEasingDuration;
      _settings.transitionSpeed = _settings.navControl.navBarEasingDuration = 0;
      setCurrentSlideId(0);
      _settings.transitionSpeed = transitionSpeed;
      _settings.navControl.navBarEasingDuration = navBarEasingDuration;
    }
    
    init();
    var instance =  { nextSlide : function () { nextSlide(); },
                      prevSlide : function () {  prevSlide(); }, 
                      goToSlide : function (id) { setCurrentSlideId(id); }
                    };
    Object.defineProperty(instance, "currSlideId", 
                          { get : function(){ return _currSlideId; },
                            set : function(id){ setCurrentSlideId(id); },
                            enumerable : true,
                            configurable : false});
    Object.defineProperty(instance, "slideCount", 
                          { get : function(){ return _allSlides.length; },
                            set : function(id){ },
                            enumerable : true,
                            configurable : false});
    return instance;
  }
  
  // here we create the interface for the jQuery plugin
  $.fn.easySlider = function( options ) {
    var settings = $.extend(true, $.fn.easySlider.defaults, options );
    if (settings.slideLoopRewind) {
      settings.slideLoop = false;
    }
    if (this.length === 0)
      print_error("No item found for easySlider");

    return this.each(function() {
      var sliderInstance = createSlider($(this), settings);
      $(this).data("easySlider", sliderInstance);
    });
  };
  
  $.fn.easySlider.defaults = {
                                transitionSpeed   : 500,
                                autoSlide         : true,
                                autoSlideTime     : 8000,
                                slideEasing       : "easeInOutQuart",
                                animation         : "scroll",
                                orientation       : "horizontal",
                                slidesDragable    : true,
                                slideByClick      : true,
                                slidesToScrollMax : 5,
                                slidesToDragMax   : 2,  
                                slideLoop         : false,
                                slideLoopRewind   : false,
                                controlsInside    : true,
                                navControl        :{
                                                      navBarStyle           : "caption", // all options are: "custom", "caption" and "none"
                                                      navBarEasing          : "easeInOutQuart",
                                                      navBarEasingDuration  : 500,
                                                      navBarAutoHide        : false,
                                                      navBarOrientation     : "horizontal",
                                                      navBarDragable        : true,
                                                      navBarItemOnHoverGoTo : false,
                                                      navBarAutoScroll      : true,
                                                      navArrowsVisible      : true,
                                                      navArrowsAutoHide     : false
                                                  }
                              };
}( jQuery ));